## heaptrack 1.0.0

=== CMakeLists.txt ===
if (CMAKE_VERSION VERSION_LESS "2.8.12")
    cmake_minimum_required(VERSION 2.8.9)
    set(HEAPTRACK_BUILD_GUI OFF)
else()
    cmake_minimum_required(VERSION 2.8.12)
endif()

project(heaptrack)
enable_testing()

if(NOT CMAKE_BUILD_TYPE)
  message(STATUS "Setting build type to 'RelWithDebInfo' as none was specified.")
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose the type of build." FORCE)
endif()

set(HEAPTRACK_VERSION_MAJOR 1)
set(HEAPTRACK_VERSION_MINOR 0)
set(HEAPTRACK_VERSION_PATCH 0)
set(HEAPTRACK_LIB_VERSION 1.0.0)
set(HEAPTRACK_LIB_SOVERSION 1)
set(HEAPTRACK_FILE_FORMAT_VERSION 1)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

find_package(Libunwind REQUIRED)
find_package(Boost 1.41.0 REQUIRED COMPONENTS iostreams program_options)
find_package(Threads REQUIRED)
find_package(ZLIB REQUIRED)
include(FeatureSummary)

option(
  HEAPTRACK_BUILD_GUI
  "Disable this option to skip building the Qt5 / KF5 based GUI for heaptrack."
  On
)

if(HEAPTRACK_BUILD_GUI)
    find_package(Qt5 5.2.0 NO_MODULE OPTIONAL_COMPONENTS Widgets)
    find_package(ECM 1.0.0 NO_MODULE)
    if(Qt5_FOUND AND ECM_FOUND)
        set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH} ${ECM_KDE_MODULE_DIR})
            find_package(KF5 OPTIONAL_COMPONENTS CoreAddons I18n ItemModels ThreadWeaver ConfigWidgets KIO)
            find_package(KChart "2.6.0")
            set_package_properties(KChart PROPERTIES TYPE RECOMMENDED PURPOSE "Required for the heaptrack_gui executable. Get it from the kdiagram module.")
    endif()
endif()

set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wall -Wpedantic")

include (CheckCXXSourceCompiles)
check_cxx_source_compiles(
    "#include <unordered_map>
    #include <atomic>
    thread_local int tls;
    int main() { return 0; }"
    HAVE_CXX11_SUPPORT)

if (NOT HAVE_CXX11_SUPPORT)
    message(FATAL_ERROR "Your compiler is too old and does not support the required C++11 features.")
endif()

check_cxx_source_compiles(
    "#include <stdio_ext.h>
    #include <fcntl.h>
    #include <dlfcn.h>
    #include <link.h>
    int main() { return 0; }"
    HAVE_LINUX_HEADERS)

if (NOT HAVE_LINUX_HEADERS)
    message(FATAL_ERROR "You are missing some Linux headers required to compile heaptrack.")
endif()

set(BIN_INSTALL_DIR "bin")
set(LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)")
set(LIB_INSTALL_DIR "lib${LIB_SUFFIX}")
set(LIBEXEC_INSTALL_DIR "${LIB_INSTALL_DIR}/heaptrack/libexec")

file(RELATIVE_PATH LIBEXEC_REL_PATH
    "${CMAKE_INSTALL_PREFIX}/${BIN_INSTALL_DIR}"
    "${CMAKE_INSTALL_PREFIX}/${LIBEXEC_INSTALL_DIR}")

file(RELATIVE_PATH LIB_REL_PATH
    "${CMAKE_INSTALL_PREFIX}/${BIN_INSTALL_DIR}"
    "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}/heaptrack")

add_subdirectory(3rdparty)
add_subdirectory(src)
add_subdirectory(tests)

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== tests/benchmarks/CMakeLists.txt ===
include_directories(../..)

include (CheckCXXSourceCompiles)
check_cxx_source_compiles(
    "#include <malloc.h>
    int main() { return mallinfo().uordblks > 0; }"
    HAVE_MALLOC_H)

if (HAVE_MALLOC_H)
    add_executable(bench_pointermap bench_pointermap.cpp)
    add_executable(bench_pointerhash bench_pointerhash.cpp)

    find_package(SparseHash)
    if(SPARSEHASH_FOUND)
        include_directories(${SPARSEHASH_INCLUDE_DIRS})
        add_executable(bench_pointersparsehash bench_pointersparsehash.cpp)
    endif()

    add_executable(measure_malloc_overhead measure_malloc_overhead.cpp)
endif()

=== tests/manual/CMakeLists.txt ===
set(CMAKE_BUILD_TYPE Debug)

add_executable(test_c test.c)
add_executable(test_cpp test.cpp)
add_executable(threaded threaded.cpp)
target_link_libraries(threaded ${CMAKE_THREAD_LIBS_INIT})

add_executable(callgraph callgraph.cpp)

add_library(testlib SHARED lib.cpp)
add_executable(test_lib test_lib.cpp)
target_link_libraries(test_lib testlib)

add_executable(test_aggregation test_aggregation.cpp)

=== src/analyze/gui/CMakeLists.txt ===
set(CMAKE_AUTOMOC 1)

ki18n_wrap_ui(UIFILES
    mainwindow.ui
)

unset(BIN_INSTALL_DIR)
unset(LIB_INSTALL_DIR)
unset(LIBEXEC_INSTALL_DIR)

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(ECMAddTests)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

configure_file(gui_config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/gui_config.h)

set(SRCFILES
    gui.cpp
    mainwindow.cpp
    treemodel.cpp
    treeproxy.cpp
    costdelegate.cpp
    modeltest.cpp
    parser.cpp
    flamegraph.cpp
    stacksmodel.cpp
    topproxy.cpp
    callercalleemodel.cpp
)

set(LIBRARIES
    Qt5::Widgets
    KF5::ItemModels
    KF5::ThreadWeaver
    KF5::ConfigWidgets
    KF5::I18n
    KF5::KIOWidgets
    sharedprint
    ${CMAKE_THREAD_LIBS_INIT}
)


if (KChart_FOUND)
    list(APPEND SRCFILES
        chartwidget.cpp
        chartmodel.cpp
        chartproxy.cpp
        histogramwidget.cpp
        histogrammodel.cpp
    )
    list(APPEND LIBRARIES
        KChart
    )
endif()

add_definitions(-Wall
    -DQT_NO_URL_CAST_FROM_STRING
    -DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_TO_ASCII
    -DQT_NO_CAST_FROM_BYTEARRAY
    -DQT_USE_QSTRINGBUILDER
)

add_executable(heaptrack_gui
    ${SRCFILES}
    ${UIFILES}
)

target_link_libraries(heaptrack_gui
    ${LIBRARIES}
)

install(TARGETS heaptrack_gui
    ${INSTALL_TARGETS_DEFAULT_ARGS}
)

set_target_properties(heaptrack_gui PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}"
)

install(PROGRAMS org.kde.heaptrack.desktop
    DESTINATION ${XDG_APPS_INSTALL_DIR}
)

install(FILES org.kde.heaptrack.appdata.xml
    DESTINATION ${KDE_INSTALL_METAINFODIR}
)

ki18n_install(po)

=== debian/changelog ===
heaptrack (1.0.0-4) unstable; urgency=medium

  * [aaf8b5c] Run unittests during the build.

 -- Anton Gladky <gladk@debian.org>  Sat, 22 Apr 2017 15:07:26 +0200

heaptrack (1.0.0-3) unstable; urgency=medium

  [ Pino Toscano ]
  * [446b623] Optimize build dependencies. (Closes: #859745)

 -- Anton Gladky <gladk@debian.org>  Sun, 09 Apr 2017 00:15:16 +0200

heaptrack (1.0.0-2) unstable; urgency=medium

  * [cf6520a] Add kio-dev as a build-dependency.
  * [8879be4] Add libheaptrack as a dependency of (Closes: #859512)

 -- Anton Gladky <gladk@debian.org>  Tue, 04 Apr 2017 18:09:48 +0200

heaptrack (1.0.0-1) unstable; urgency=medium

  * Initial upload. (Closes: #858858)

 -- Anton Gladky <gladk@debian.org>  Fri, 20 Jan 2017 20:14:59 +0100

=== debian/control ===
Source: heaptrack
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Anton Gladky <gladk@debian.org>
Section: devel
Priority: optional
Build-Depends: cmake,
               debhelper (>= 10),
               qtbase5-dev,
               qtbase5-dev-tools,
               libkf5kio-dev,
               libkf5configwidgets-dev,
               libkf5threadweaver-dev,
               libkf5itemmodels-dev,
               libkf5i18n-dev,
               libkchart-dev,
               libdwarf-dev,
               libelf-dev,
               extra-cmake-modules,
               libunwind-dev,
               libboost-iostreams-dev,
               libboost-program-options-dev,
               libboost-regex-dev,
               zlib1g-dev,
               libsparsehash-dev
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/heaptrack.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/heaptrack.git
Homepage: https://github.com/KDE/heaptrack

Package: heaptrack
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libheaptrack (= ${binary:Version})
Description: Heap memory profiler for Linux
 Heap memory usage profiler. It uses LD_PRELOAD to track all
 calls to the core memory allocation functions and logs these
 occurrences. Additionally, backtraces are obtained and logged.
 .
 The package contains command line tools.

Package: heaptrack-gui
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Heap memory profiler for Linux
 Heap memory usage profiler. It uses LD_PRELOAD to track all
 calls to the core memory allocation functions and logs these
 occurrences. Additionally, backtraces are obtained and logged.
 .
 The package contains GUI for the data analyze.

Package: libheaptrack
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Heap memory profiler for Linux
 Heap memory usage profiler. It uses LD_PRELOAD to track all
 calls to the core memory allocation functions and logs these
 occurrences. Additionally, backtraces are obtained and logged.
 .
 The package contains shared libraries.

=== debian/rules ===
#!/usr/bin/make -f
BUILDDIR = $(CURDIR)/debian/build

%:
	dh $@ --builddirectory=$(BUILDDIR)

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=Debug

# Unittests are explicitly set to "true" due to their failures.
# The "|| true" should be removed, when #860949 is resolved
override_dh_auto_install:
	dh_auto_install
	cd $(BUILDDIR) ; $(MAKE) test ARGS=-VV || true

override_dh_auto_test:

## heaptrack 1.0.1~20170503.git4da8c45

=== 3rdparty/CMakeLists.txt ===
add_subdirectory(libbacktrace/)

=== 3rdparty/libbacktrace/CMakeLists.txt ===
# based on: https://github.com/ValveSoftware/vogl/blob/master/src/libbacktrace/CMakeLists.txt
#
#    CMakeLists.txt -- libbacktrace CMake build script
#    Contributed by Alexander Monakov, ISP RAS
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     (1) Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#
#     (2) Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in
#     the documentation and/or other materials provided with the
#     distribution.
#
#     (3) The name of the author may not be used to
#     endorse or promote products derived from this software without
#     specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
# IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.  */

cmake_minimum_required (VERSION 2.8)

project (libbacktrace)

set (BACKTRACE_SUPPORTED 1)

include (CheckSymbolExists)
if (true)
    # When unwind.h is in /usr/local/include, check_symbol_exists() is failing. But
    #  these functions are in the Linux Standard Base Core Spec and should just exist
    #  for Linux, yes?  I'm assuming that's the case for now and using them.
    #  (Otherwise stack tracing won't work anyway).
    set (HAVE_BACKTRACE 1)
    set (HAVE_GETIPINFO 1)
else()
    check_symbol_exists (_Unwind_Backtrace unwind.h HAVE_BACKTRACE)
    check_symbol_exists (_Unwind_GetIPInfo unwind.h HAVE_GETIPINFO)
endif()

if (HAVE_BACKTRACE)
    set (BACKTRACE_FILE backtrace.c simple.c)
else ()
    message(FATAL_ERROR "Could not find unwind.h, install the libunwind development package.")
endif ()

include (CheckCCompilerFlag)
check_c_compiler_flag ("-funwind-tables" FLAG_UNWIND_TABLES)
if (FLAG_UNWIND_TABLES)
    add_definitions ("-funwind-tables")
endif ()

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    add_definitions("-D_DEBUG -DDEBUG")
endif()

# Adjust warnings
if (CMAKE_COMPILER_IS_GNUCC)
    add_definitions ("-Wno-switch -Wno-enum-compare")
endif ()

# Add these compiler options to match how voglcore and voglcommon are compiled, and to get libbacktrace compiling with gcc.
# -fno-strict-aliasing is particularly important if voglcore is called, and -fvisibility=hidden must be used otherwide symbols from this lib could be made visible in libvogltrace.
add_definitions ("-g -fno-omit-frame-pointer -fno-strict-aliasing -fno-math-errno -fvisibility=hidden")
SET(CMAKE_CXX_FLAGS_RELEASE "-O2 -g -DNDEBUG")

if ("${CMAKE_C_COMPILER_ID}" STREQUAL "Clang")
   if ( NOT BUILD_X64 )
      # Fix startup crash in dlopen_notify_callback (called indirectly from our dlopen() function) when tracing glxspheres on my AMD dev box (x86 release only)
      #add_definitions ("-mstack-alignment=8")
   endif()
endif()

# clang doesn't print colored diagnostics when invoked from Ninja
if ("${CMAKE_C_COMPILER_ID}" STREQUAL "Clang")
  if (UNIX AND CMAKE_GENERATOR STREQUAL "Ninja")
      add_definitions ("-fcolor-diagnostics")
  endif()
endif()

check_c_source_compiles (
    "int i;
    int main() {
    __sync_bool_compare_and_swap (&i, i, i);
    __sync_lock_test_and_set (&i, 1);
    __sync_lock_release (&i);}"
    HAVE_SYNC_FUNCTIONS)

check_c_source_compiles (
    "int i;
    int main() {
    __atomic_load_n (&i, __ATOMIC_ACQUIRE);
    __atomic_store_n (&i, i, __ATOMIC_RELEASE);}"
    HAVE_ATOMIC_FUNCTIONS)

if (HAVE_SYNC_FUNCTIONS OR HAVE_ATOMIC_FUNCTIONS)
    set (BACKTRACE_SUPPORTS_THREADS 1)
else ()
    set (BACKTRACE_SUPPORTS_THREADS 0)
endif ()

include(CMakeDetermineCompilerId)
if (CMAKE_EXECUTABLE_FORMAT STREQUAL "ELF")
    set (FORMAT_FILE elf.c dwarf.c)
    math (EXPR BACKTRACE_ELF_SIZE 8*${CMAKE_C_SIZEOF_DATA_PTR})
else ()
    message(FATAL_ERROR "Unknown executable format \"${CMAKE_EXECUTABLE_FORMAT}\", currently only ELF is supported.")
endif ()

check_symbol_exists (mmap sys/mman.h HAVE_MMAP)

# NOTE: For the use-case of heaptrack, we want to use malloc for allocating
# the tiny fragments required for reading a backtrace as we are doing this
# in a separate process, outside of a potential signal handler
# This has a tremendous impact on the performance when analyzing the DWARF
# symbols of a large binary, such as clang++ or webkit.
set (ALLOC_FILE alloc.c)
set (BACKTRACE_USES_MALLOC 1)

if (HAVE_MMAP)
    set (VIEW_FILE mmapio.c)
    check_symbol_exists (MAP_ANONYMOUS sys/mman.h HAVE_MMAP_ANONYMOUS)
    check_symbol_exists (MAP_ANON sys/mman.h HAVE_MMAP_ANON)
else ()
    set (VIEW_FILE read.c)
endif ()

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    add_definitions("-D_DEBUG -DDEBUG")
endif()
add_definitions (-D_GNU_SOURCE)
set (CMAKE_REQUIRED_DEFINITIONS ${CMAKE_REQUIRED_DEFINITIONS} -D_GNU_SOURCE)
check_symbol_exists (dl_iterate_phdr link.h HAVE_DL_ITERATE_PHDR)

include (CheckFunctionExists)
check_function_exists (fcntl HAVE_FCNTL)

check_function_exists (strnlen HAVE_DECL_STRNLEN)

check_function_exists (getexecname HAVE_GETEXECNAME)

include (CheckIncludeFile)
find_path(DWARF_INCLUDE_DIR dwarf.h
      PATH_SUFFIXES libdwarf)
if (NOT DWARF_INCLUDE_DIR)
    message(FATAL_ERROR "Could not find dwarf.h, try installing the dwarf or elfutils development package.")
endif ()
include_directories(${DWARF_INCLUDE_DIR})

configure_file (backtrace-supported.h.in backtrace-supported.h)

configure_file (config.h.in.cmake config.h)

include_directories (BEFORE
    ${CMAKE_CURRENT_BINARY_DIR}
)
include_directories (
    auxincl
    ${LIBUNWIND_INCLUDE_DIR}
)

add_library (backtrace STATIC
    ${BACKTRACE_FILE}
    ${FORMAT_FILE}
    ${VIEW_FILE}
    ${ALLOC_FILE}
    atomic.c
    fileline.c
    posix.c
    print.c
    state.c
    sort.c
)

target_link_libraries(backtrace ${LIBUNWIND_LIBRARY})

set_target_properties (backtrace PROPERTIES
    COMPILE_FLAGS "${CMAKE_SHARED_LIBRARY_C_FLAGS}"
)

=== tests/manual/CMakeLists.txt ===
--- 
+++ 
@@ -12,3 +12,8 @@
 target_link_libraries(test_lib testlib)
 
 add_executable(test_aggregation test_aggregation.cpp)
+
+add_executable(signals signals.cpp)
+target_link_libraries(signals ${CMAKE_THREAD_LIBS_INIT})
+
+add_executable(libc_leaks libc_leaks.c)

=== src/analyze/gui/CMakeLists.txt ===
--- 
+++ 
@@ -23,7 +23,6 @@
     treemodel.cpp
     treeproxy.cpp
     costdelegate.cpp
-    modeltest.cpp
     parser.cpp
     flamegraph.cpp
     stacksmodel.cpp
@@ -87,5 +86,3 @@
 install(FILES org.kde.heaptrack.appdata.xml
     DESTINATION ${KDE_INSTALL_METAINFODIR}
 )
-
-ki18n_install(po)

=== debian/changelog ===
heaptrack (1.0.1~20170503.git4da8c45-3) unstable; urgency=medium

  * [dfbead4] Allow stderr output in autopkgtest.

 -- Anton Gladky <gladk@debian.org>  Sun, 07 May 2017 23:12:12 +0200

heaptrack (1.0.1~20170503.git4da8c45-2) unstable; urgency=medium

  * [50e65ec] Disable unittests on mips due to crash in a third lib.
              (Closes: #861826)
  * [f7f6bed] Add d/watch.
  * [84c5439] Add simple autopkgtest.

 -- Anton Gladky <gladk@debian.org>  Sun, 07 May 2017 19:16:18 +0200

heaptrack (1.0.1~20170503.git4da8c45-1) unstable; urgency=medium

  [ Milian Wolff ]
  * [3977193] Fix unittests due to libunwind. (Closes: #860949)

  [ Anton Gladky ]
  * [80b8ee3] Do not override failing of unittests.
  * [6ef6b77] Ignore quilt dir
  * [56de1cc] Do not build in Debug-mode.
  * [ee63343] Add script to download heaptrack from github.
  * [8dd4054] New upstream version 1.0.1~20170503.git4da8c45

 -- Anton Gladky <gladk@debian.org>  Wed, 03 May 2017 22:32:13 +0200

=== debian/control ===
--- 
+++ 
@@ -2,6 +2,7 @@
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Anton Gladky <gladk@debian.org>
 Section: devel
+Testsuite: autopkgtest
 Priority: optional
 Build-Depends: cmake,
                debhelper (>= 10),

=== debian/tests/control ===
Tests: 01_heaptrack
Depends: heaptrack
Restrictions: allow-stderr

## heaptrack 1.0.1~20180129.gita4534d5

=== CMakeLists.txt ===
--- 
+++ 
@@ -18,7 +18,7 @@
 set(HEAPTRACK_VERSION_PATCH 0)
 set(HEAPTRACK_LIB_VERSION 1.0.0)
 set(HEAPTRACK_LIB_SOVERSION 1)
-set(HEAPTRACK_FILE_FORMAT_VERSION 1)
+set(HEAPTRACK_FILE_FORMAT_VERSION 2)
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
 
@@ -39,7 +39,7 @@
     find_package(ECM 1.0.0 NO_MODULE)
     if(Qt5_FOUND AND ECM_FOUND)
         set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH} ${ECM_KDE_MODULE_DIR})
-            find_package(KF5 OPTIONAL_COMPONENTS CoreAddons I18n ItemModels ThreadWeaver ConfigWidgets KIO)
+            find_package(KF5 COMPONENTS CoreAddons I18n ItemModels ThreadWeaver ConfigWidgets KIO)
             find_package(KChart "2.6.0")
             set_package_properties(KChart PROPERTIES TYPE RECOMMENDED PURPOSE "Required for the heaptrack_gui executable. Get it from the kdiagram module.")
     endif()
@@ -73,6 +73,11 @@
     message(FATAL_ERROR "You are missing some Linux headers required to compile heaptrack.")
 endif()
 
+# cfree() does not exist in glibc 2.26+.
+# See: https://bugs.kde.org/show_bug.cgi?id=383889
+include(CheckSymbolExists)
+check_symbol_exists(cfree malloc.h HAVE_CFREE)
+
 set(BIN_INSTALL_DIR "bin")
 set(LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)")
 set(LIB_INSTALL_DIR "lib${LIB_SUFFIX}")

=== tests/CMakeLists.txt ===
add_subdirectory(manual)
add_subdirectory(auto)
add_subdirectory(benchmarks)

=== 3rdparty/libbacktrace/CMakeLists.txt ===
--- 
+++ 
@@ -120,6 +120,8 @@
 endif ()
 
 check_symbol_exists (mmap sys/mman.h HAVE_MMAP)
+check_symbol_exists(lstat sys/stat.h HAVE_LSTAT)
+check_symbol_exists(readlink unistd.h HAVE_READLINK)
 
 # NOTE: For the use-case of heaptrack, we want to use malloc for allocating
 # the tiny fragments required for reading a backtrace as we are doing this

=== src/analyze/CMakeLists.txt ===
include_directories(
    ${Boost_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIRS}
)

add_library(sharedprint STATIC
    accumulatedtracedata.cpp
)

target_link_libraries(sharedprint LINK_PUBLIC
    ${Boost_LIBRARIES}
    ${ZLIB_LIBRARIES}
)

add_subdirectory(print)

if (KF5_FOUND)
    add_subdirectory(gui)
endif()

=== src/interpret/CMakeLists.txt ===
include_directories(
    ${Boost_INCLUDE_DIRS}
    ${PROJECT_SOURCE_DIR}/3rdparty/
    ${ZLIB_INCLUDE_DIRS}
)

add_executable(heaptrack_interpret
    heaptrack_interpret.cpp
)

target_link_libraries(heaptrack_interpret
    backtrace
)

install(TARGETS heaptrack_interpret
    RUNTIME DESTINATION ${LIBEXEC_INSTALL_DIR}
)

set_target_properties(heaptrack_interpret PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${LIBEXEC_INSTALL_DIR}"
)

=== src/track/CMakeLists.txt ===
include_directories(
    ${Boost_INCLUDE_DIRS}
    ${LIBUNWIND_INCLUDE_DIR}
)

# heaptrack: bash script to inject/preload
configure_file(heaptrack.sh.cmake
    ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/heaptrack @ONLY
)

install(PROGRAMS ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/heaptrack
    DESTINATION ${BIN_INSTALL_DIR}
)

# heaptrack_preload: track a newly started process
add_library(heaptrack_preload MODULE
    heaptrack_preload.cpp
    libheaptrack.cpp
)

target_link_libraries(heaptrack_preload LINK_PRIVATE
    ${CMAKE_DL_LIBS}
    ${CMAKE_THREAD_LIBS_INIT}
    ${LIBUNWIND_LIBRARY}
    rt
)

set_target_properties(heaptrack_preload PROPERTIES
    VERSION ${HEAPTRACK_LIB_VERSION}
    SOVERSION ${HEAPTRACK_LIB_SOVERSION}
    LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${LIB_INSTALL_DIR}/heaptrack"
)

install(TARGETS heaptrack_preload
    LIBRARY DESTINATION ${LIB_INSTALL_DIR}/heaptrack/
)

# heaptrack_inject: track an already running process
add_library(heaptrack_inject MODULE
    heaptrack_inject.cpp
    libheaptrack.cpp
)

target_link_libraries(heaptrack_inject LINK_PRIVATE
    ${CMAKE_DL_LIBS}
    ${CMAKE_THREAD_LIBS_INIT}
    ${LIBUNWIND_LIBRARY}
    rt
)

set_target_properties(heaptrack_inject PROPERTIES
    VERSION ${HEAPTRACK_LIB_VERSION}
    SOVERSION ${HEAPTRACK_LIB_SOVERSION}
    LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${LIB_INSTALL_DIR}/heaptrack"
)

install(TARGETS heaptrack_inject
    LIBRARY DESTINATION ${LIB_INSTALL_DIR}/heaptrack/
)

# public API for custom pool allocators or static binaries
install(FILES heaptrack_api.h
    DESTINATION ${CMAKE_INSTALL_PREFIX}/include
)

=== tests/auto/CMakeLists.txt ===
set(CMAKE_BUILD_TYPE Debug)

include_directories(
    ${LIBUNWIND_INCLUDE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/../../
)
add_definitions(-DCATCH_CONFIG_MAIN)
add_executable(tst_trace tst_trace.cpp)
target_link_libraries(tst_trace ${LIBUNWIND_LIBRARY})
add_test(NAME tst_trace COMMAND tst_trace )

=== tests/benchmarks/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,7 @@
-include_directories(../..)
+include_directories(
+    ../..
+    ${Boost_INCLUDE_DIRS}
+)
 
 include (CheckCXXSourceCompiles)
 check_cxx_source_compiles(

=== src/analyze/gui/CMakeLists.txt ===
--- 
+++ 
@@ -28,6 +28,7 @@
     stacksmodel.cpp
     topproxy.cpp
     callercalleemodel.cpp
+    util.cpp
 )
 
 set(LIBRARIES
@@ -86,3 +87,16 @@
 install(FILES org.kde.heaptrack.appdata.xml
     DESTINATION ${KDE_INSTALL_METAINFODIR}
 )
+
+include(ECMInstallIcons)
+ecm_install_icons(ICONS
+  16-apps-heaptrack.png
+  22-apps-heaptrack.png
+  32-apps-heaptrack.png
+  48-apps-heaptrack.png
+  64-apps-heaptrack.png
+  128-apps-heaptrack.png
+  sc-apps-heaptrack.svg
+  DESTINATION ${KDE_INSTALL_ICONDIR}
+  THEME hicolor
+)

=== src/analyze/print/CMakeLists.txt ===
add_executable(heaptrack_print
    heaptrack_print.cpp
)

target_link_libraries(heaptrack_print LINK_PRIVATE
    sharedprint
    ${CMAKE_THREAD_LIBS_INIT}
)

install(TARGETS heaptrack_print
    RUNTIME DESTINATION ${BIN_INSTALL_DIR}
)

set_target_properties(heaptrack_print PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}"
)

=== debian/changelog ===
heaptrack (1.0.1~20180129.gita4534d5-1) unstable; urgency=medium

  * [a6dc2c1] New upstream version 0~20180129.gita4534d5. (Closes: #887757)
  * [718fc77] Disable KDE test
  * [2e67083] Ignore quilt dir
  * [29e6221] Apply cme fix dpkg
  * [d2703ab] Remove testsuite-field in d/control
  * [429a120] Update VCS-field (move to salsa)
  * [3c1ec4b] Use compat-level 11
  * [e8b0aa0] Update autopkgtest
  * [810d33c] Add one more autopkgtest

 -- Anton Gladky <gladk@debian.org>  Sat, 03 Feb 2018 20:36:37 +0100

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,9 @@
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Anton Gladky <gladk@debian.org>
 Section: devel
-Testsuite: autopkgtest
 Priority: optional
 Build-Depends: cmake,
-               debhelper (>= 10),
+               debhelper (>= 11),
                qtbase5-dev,
                qtbase5-dev-tools,
                libkf5kio-dev,
@@ -23,9 +22,9 @@
                libboost-regex-dev,
                zlib1g-dev,
                libsparsehash-dev
-Standards-Version: 3.9.8
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/heaptrack.git
-Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/heaptrack.git
+Standards-Version: 4.1.3
+Vcs-Browser: https://salsa.debian.org/science-team/heaptrack.git
+Vcs-Git: https://salsa.debian.org/science-team/heaptrack.git
 Homepage: https://github.com/KDE/heaptrack
 
 Package: heaptrack

## heaptrack 1.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,19 +14,22 @@
 endif()
 
 set(HEAPTRACK_VERSION_MAJOR 1)
-set(HEAPTRACK_VERSION_MINOR 0)
+set(HEAPTRACK_VERSION_MINOR 1)
 set(HEAPTRACK_VERSION_PATCH 0)
-set(HEAPTRACK_LIB_VERSION 1.0.0)
-set(HEAPTRACK_LIB_SOVERSION 1)
+set(HEAPTRACK_LIB_VERSION 1.1.0)
+set(HEAPTRACK_LIB_SOVERSION 2)
 set(HEAPTRACK_FILE_FORMAT_VERSION 2)
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
 
+include(FeatureSummary)
 find_package(Libunwind REQUIRED)
-find_package(Boost 1.41.0 REQUIRED COMPONENTS iostreams program_options)
+find_package(Boost 1.41.0 COMPONENTS system filesystem) # option first
+find_package(Boost 1.41.0 REQUIRED COMPONENTS iostreams program_options) # then required
 find_package(Threads REQUIRED)
 find_package(ZLIB REQUIRED)
-include(FeatureSummary)
+find_package(Zstd)
+set_package_properties(Zstd PROPERTIES TYPE RECOMMENDED PURPOSE "Zstandard offers better (de)compression performance compared with gzip/zlib, making heaptrack faster and datafiles smaller.")
 
 option(
   HEAPTRACK_BUILD_GUI
@@ -91,6 +94,8 @@
     "${CMAKE_INSTALL_PREFIX}/${BIN_INSTALL_DIR}"
     "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}/heaptrack")
 
+set(ECM_ENABLE_SANITIZERS "" CACHE STRING "semicolon-separated list of sanitizers to enable for code that is not injected into client applications")
+
 add_subdirectory(3rdparty)
 add_subdirectory(src)
 add_subdirectory(tests)

=== tests/auto/CMakeLists.txt ===
if (ECM_FOUND)
    include(ECMEnableSanitizers)
endif()

set(CMAKE_BUILD_TYPE Debug)
configure_file(tst_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/tst_config.h @ONLY)

include_directories(
    ${LIBUNWIND_INCLUDE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/../../
    ${CMAKE_CURRENT_SOURCE_DIR}/../../src
)
add_definitions(-DCATCH_CONFIG_MAIN)

add_executable(tst_trace tst_trace.cpp)
target_link_libraries(tst_trace ${LIBUNWIND_LIBRARY})
add_test(NAME tst_trace COMMAND tst_trace)

if (${Boost_FILESYSTEM_FOUND} AND ${Boost_SYSTEM_FOUND})
    include_directories(
        ${Boost_INCLUDE_DIRS}
        ${CMAKE_CURRENT_BINARY_DIR}/../../src/
        ${CMAKE_CURRENT_SOURCE_DIR}/../../src/track
    )
    add_executable(tst_libheaptrack
        tst_libheaptrack.cpp
        ../../src/track/libheaptrack.cpp)
    target_link_libraries(tst_libheaptrack
        LINK_PRIVATE
            ${CMAKE_DL_LIBS}
            ${CMAKE_THREAD_LIBS_INIT}
            ${LIBUNWIND_LIBRARY}
            rt
            ${Boost_SYSTEM_LIBRARY}
            ${Boost_FILESYSTEM_LIBRARY}
    )
    add_test(NAME tst_libheaptrack COMMAND tst_libheaptrack)

    add_executable(tst_io tst_io.cpp)
    target_link_libraries(tst_io
            ${Boost_SYSTEM_LIBRARY}
            ${Boost_FILESYSTEM_LIBRARY}
    )
    add_test(NAME tst_io COMMAND tst_io)


    add_executable(tst_inject tst_inject.cpp)
    target_link_libraries(tst_inject
            ${CMAKE_DL_LIBS}
            ${Boost_SYSTEM_LIBRARY}
            ${Boost_FILESYSTEM_LIBRARY}
    )
    add_test(NAME tst_inject COMMAND tst_inject)

endif()

=== debian/changelog ===
heaptrack (1.1.0-3build1) cosmic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Jul 2018 13:13:31 +0000

heaptrack (1.1.0-3) unstable; urgency=medium

  * [039b42f] Disable two failing tests.

 -- Anton Gladky <gladk@debian.org>  Thu, 14 Jun 2018 18:37:22 +0200

heaptrack (1.1.0-2) unstable; urgency=medium

  * [31bf7e2] Add libzstd-dev to build-depends
  * [db25410] Add libboost-filesystem-dev and libboost-system-dev
              to build-depends
  * [e2bf4ab] Enable all tests to check them on all archs

 -- Anton Gladky <gladk@debian.org>  Wed, 13 Jun 2018 23:56:20 +0200

heaptrack (1.1.0-1) unstable; urgency=medium

  * [ed3605b] Update script for the packing the source
  * [39ada17] New upstream version 1.1.0. (Closes: #901049)
  * [1ea6a50] Set Standards-Version to 4.1.4
  * [640f04e] Update changelog.

 -- Anton Gladky <gladk@debian.org>  Tue, 12 Jun 2018 21:19:13 +0200

=== debian/control ===
--- 
+++ 
@@ -18,11 +18,14 @@
                extra-cmake-modules,
                libunwind-dev,
                libboost-iostreams-dev,
+               libboost-filesystem-dev,
+               libboost-system-dev,
                libboost-program-options-dev,
                libboost-regex-dev,
                zlib1g-dev,
+               libzstd-dev,
                libsparsehash-dev
-Standards-Version: 4.1.3
+Standards-Version: 4.1.4
 Vcs-Browser: https://salsa.debian.org/science-team/heaptrack.git
 Vcs-Git: https://salsa.debian.org/science-team/heaptrack.git
 Homepage: https://github.com/KDE/heaptrack

=== debian/tests/control ===
Tests: 01-heaptrack 02-heaptrack
Depends: heaptrack
Restrictions: allow-stderr

## heaptrack 1.1.0+20180922.gitf752536

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,8 +15,8 @@
 
 set(HEAPTRACK_VERSION_MAJOR 1)
 set(HEAPTRACK_VERSION_MINOR 1)
-set(HEAPTRACK_VERSION_PATCH 0)
-set(HEAPTRACK_LIB_VERSION 1.1.0)
+set(HEAPTRACK_VERSION_PATCH 80)
+set(HEAPTRACK_LIB_VERSION 1.1.80)
 set(HEAPTRACK_LIB_SOVERSION 2)
 set(HEAPTRACK_FILE_FORMAT_VERSION 2)

=== 3rdparty/CMakeLists.txt ===
if (ECM_FOUND)
    include(ECMEnableSanitizers)
endif()

add_subdirectory(libbacktrace)

if (ZSTD_FOUND)
add_subdirectory(boost-zstd)
endif()

=== src/CMakeLists.txt ===
include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
)

add_subdirectory(util)
add_subdirectory(track)
add_subdirectory(interpret)
add_subdirectory(analyze)

=== src/analyze/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,14 @@
+if (ECM_FOUND)
+    include(ECMEnableSanitizers)
+endif()
+
+configure_file(analyze_config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/analyze_config.h)
+
 include_directories(
     ${Boost_INCLUDE_DIRS}
     ${ZLIB_INCLUDE_DIRS}
+    ${PROJECT_SOURCE_DIR}/3rdparty/
+    ${CMAKE_CURRENT_BINARY_DIR}
 )
 
 add_library(sharedprint STATIC
@@ -12,6 +20,12 @@
     ${ZLIB_LIBRARIES}
 )
 
+if (ZSTD_FOUND)
+target_link_libraries(sharedprint LINK_PUBLIC
+    boost-zstd
+)
+endif()
+
 add_subdirectory(print)
 
 if (KF5_FOUND)

=== src/interpret/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,7 @@
+if (ECM_FOUND)
+    include(ECMEnableSanitizers)
+endif()
+
 include_directories(
     ${Boost_INCLUDE_DIRS}
     ${PROJECT_SOURCE_DIR}/3rdparty/

=== tests/auto/CMakeLists.txt ===
--- 
+++ 
@@ -17,7 +17,7 @@
 target_link_libraries(tst_trace ${LIBUNWIND_LIBRARY})
 add_test(NAME tst_trace COMMAND tst_trace)
 
-if (${Boost_FILESYSTEM_FOUND} AND ${Boost_SYSTEM_FOUND})
+if ("${Boost_FILESYSTEM_FOUND}" AND "${Boost_SYSTEM_FOUND}")
     include_directories(
         ${Boost_INCLUDE_DIRS}
         ${CMAKE_CURRENT_BINARY_DIR}/../../src/

=== tests/benchmarks/CMakeLists.txt ===
include_directories(
    ../..
    ${Boost_INCLUDE_DIRS}
)

include (CheckCXXSourceCompiles)
check_cxx_source_compiles(
    "#include <malloc.h>
    int main() { return mallinfo().uordblks > 0; }"
    HAVE_MALLOC_H)

if (HAVE_MALLOC_H)
    add_executable(bench_pointermap bench_pointermap.cpp)
    add_executable(bench_pointerhash bench_pointerhash.cpp)

    add_executable(measure_malloc_overhead measure_malloc_overhead.cpp)
endif()

=== debian/changelog ===
heaptrack (1.1.0+20180922.gitf752536-4) unstable; urgency=medium

  [ Nicholas D Steeves ]
  * [58b38ee] Update description to make heaptrack more discoverable to users.
              (Closes: #915241)

 -- Anton Gladky <gladk@debian.org>  Wed, 27 Feb 2019 09:44:39 +0200

heaptrack (1.1.0+20180922.gitf752536-3) unstable; urgency=medium

  * [0b640ca] Fix broken patch

 -- Anton Gladky <gladk@debian.org>  Sat, 29 Sep 2018 15:27:56 +0200

heaptrack (1.1.0+20180922.gitf752536-2) unstable; urgency=medium

  * [143f6cc] Disable some more tests

 -- Anton Gladky <gladk@debian.org>  Sat, 29 Sep 2018 14:56:15 +0200

heaptrack (1.1.0+20180922.gitf752536-1) unstable; urgency=medium

  * [1197d65] New upstream version 1.1.0+20180922.gitf752536. (Closes: #902200)
  * [7f2a7ba] Disable some failing tests for a while
  * [fc4a172] Fix spelling error
  * [0b1ee0e] Set Standards-Version: 4.2.1

 -- Anton Gladky <gladk@debian.org>  Sat, 29 Sep 2018 10:00:48 +0200

=== debian/control ===
Source: heaptrack
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Anton Gladky <gladk@debian.org>
Section: devel
Priority: optional
Build-Depends: cmake,
               debhelper (>= 11),
               qtbase5-dev,
               qtbase5-dev-tools,
               libkf5kio-dev,
               libkf5configwidgets-dev,
               libkf5threadweaver-dev,
               libkf5itemmodels-dev,
               libkf5i18n-dev,
               libkchart-dev,
               libdwarf-dev,
               libelf-dev,
               extra-cmake-modules,
               libunwind-dev,
               libboost-iostreams-dev,
               libboost-filesystem-dev,
               libboost-system-dev,
               libboost-program-options-dev,
               libboost-regex-dev,
               zlib1g-dev,
               libzstd-dev,
               libsparsehash-dev
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/science-team/heaptrack.git
Vcs-Git: https://salsa.debian.org/science-team/heaptrack.git
Homepage: https://github.com/KDE/heaptrack

Package: heaptrack
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libheaptrack (= ${binary:Version})
Description: heap memory profiler for Linux
 Heap memory usage profiler. It uses LD_PRELOAD to track all calls
 to the core memory allocation functions and logs these occurrences.
 Additionally, backtraces are obtained and logged. It can also
 generate a historigram of allocation sizes over the number of
 calls. Heaptrack measures the following:
 .
   * Heap memory consumption (like Massif).
   * Number of calls to allocation functions (like callgrind).
   * Total amount of memory allocated, ignoring deallocations.
   * Leaked memory (like memcheck).
 .
 Heaptrack is notable for it's ability to attach to running processes,
 for consuming substantially less memory than Valgrind, and for not
 reducing an application's interactivity as much as Valgrind does.
 Heaptrack is useful for debugging memory leaks and memory ballooning.
 .
 The package contains the command line tools.

Package: heaptrack-gui
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: heap memory profiler for Linux
 Heap memory usage profiler. It uses LD_PRELOAD to track all calls
 to the core memory allocation functions and logs these occurrences.
 Additionally, backtraces are obtained and logged. It can also
 generate a historigram of allocation sizes over the number of
 calls. Heaptrack measures the following:
 .
   * Heap memory consumption (like Massif).
   * Number of calls to allocation functions (like callgrind).
   * Total amount of memory allocated, ignoring deallocations.
   * Leaked memory (like memcheck).
 .
 Heaptrack is notable for it's ability to attach to running processes,
 for consuming substantially less memory than Valgrind, and for not
 reducing an application's interactivity as much as Valgrind does.
 Heaptrack is useful for debugging memory leaks and memory ballooning.
 .
 The package contains the GUI for data analysis.

Package: libheaptrack
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: heap memory profiler for Linux
 Heap memory usage profiler. It uses LD_PRELOAD to track all calls
 to the core memory allocation functions and logs these occurrences.
 Additionally, backtraces are obtained and logged. It can also
 generate a historigram of allocation sizes over the number of
 calls. Heaptrack measures the following:
 .
   * Heap memory consumption (like Massif).
   * Number of calls to allocation functions (like callgrind).
   * Total amount of memory allocated, ignoring deallocations.
   * Leaked memory (like memcheck).
 .
 Heaptrack is notable for it's ability to attach to running processes,
 for consuming substantially less memory than Valgrind, and for not
 reducing an application's interactivity as much as Valgrind does.
 Heaptrack is useful for debugging memory leaks and memory ballooning.
 .
 The package contains the shared libraries.

=== debian/rules ===
#!/usr/bin/make -f
BUILDDIR = $(CURDIR)/debian/build

%:
	dh $@ --builddirectory=$(BUILDDIR)

# Unittests are disabled on mips due to build failures
# It looks like the crash is happening in libunwind,
# needs to be investigated
#
# https://sources.debian.net/src/libunwind/1.1-4.1/debian/rules/#L34
ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
ifneq (mips, $(DEB_BUILD_ARCH))
override_dh_auto_install:
	dh_auto_install
	cd $(BUILDDIR) ; $(MAKE) test ARGS=-VV
endif # amd64
endif # nocheck

override_dh_auto_test:

## heaptrack 1.2.0

=== src/track/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,5 @@
 include_directories(
     ${Boost_INCLUDE_DIRS}
-    ${LIBUNWIND_INCLUDE_DIR}
 )
 
 # heaptrack: bash script to inject/preload
@@ -12,6 +11,17 @@
     DESTINATION ${BIN_INSTALL_DIR}
 )
 
+if (HEAPTRACK_USE_LIBUNWIND)
+    include_directories(${LIBUNWIND_INCLUDE_DIR})
+
+    add_library(heaptrack_unwind STATIC trace_libunwind.cpp)
+    target_link_libraries(heaptrack_unwind LINK_PRIVATE ${LIBUNWIND_LIBRARY})
+else()
+    add_library(heaptrack_unwind STATIC trace_unwind_tables.cpp)
+endif()
+
+set_property(TARGET heaptrack_unwind PROPERTY POSITION_INDEPENDENT_CODE ON)
+
 # heaptrack_preload: track a newly started process
 add_library(heaptrack_preload MODULE
     heaptrack_preload.cpp
@@ -21,7 +31,7 @@
 target_link_libraries(heaptrack_preload LINK_PRIVATE
     ${CMAKE_DL_LIBS}
     ${CMAKE_THREAD_LIBS_INIT}
-    ${LIBUNWIND_LIBRARY}
+    heaptrack_unwind
     rt
 )
 
@@ -44,7 +54,7 @@
 target_link_libraries(heaptrack_inject LINK_PRIVATE
     ${CMAKE_DL_LIBS}
     ${CMAKE_THREAD_LIBS_INIT}
-    ${LIBUNWIND_LIBRARY}
+    heaptrack_unwind
     rt
 )

=== debian/changelog ===
heaptrack (1.2.0-1) unstable; urgency=medium

  * [f3ec34f] New upstream version 1.2.0
  * [a42d5a3] Remove unreliable patches
  * [9373ca1] Ignore quilt dir
  * [2322fe2] Bump debhelper from old 11 to 12.
  * [5479da2] Set debhelper-compat version in Build-Depends.
  * [9ba9600] Use canonical URL in Vcs-Browser.
  * [306c516] Set Standards-Version 4.5.0. No changes

 -- Anton Gladky <gladk@debian.org>  Fri, 20 Nov 2020 22:05:40 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Section: devel
 Priority: optional
 Build-Depends: cmake,
-               debhelper (>= 11),
+               debhelper-compat (= 12),
                qtbase5-dev,
                qtbase5-dev-tools,
                libkf5kio-dev,
@@ -25,8 +25,8 @@
                zlib1g-dev,
                libzstd-dev,
                libsparsehash-dev
-Standards-Version: 4.2.1
-Vcs-Browser: https://salsa.debian.org/science-team/heaptrack.git
+Standards-Version: 4.5.0
+Vcs-Browser: https://salsa.debian.org/science-team/heaptrack
 Vcs-Git: https://salsa.debian.org/science-team/heaptrack.git
 Homepage: https://github.com/KDE/heaptrack

=== debian/watch ===
version=3
opts=uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|b|a)\d*)$/$1~$2/,dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$// \
https://github.com/KDE/heaptrack/tags .*/v(\d.*)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))
